/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.seguridad;

import com.rjconsultores.ventaboletos.entidad.FuncionSistema;
import com.rjconsultores.ventaboletos.entidad.Sistema;
import com.rjconsultores.ventaboletos.service.FuncionSistemaService;
import com.rjconsultores.ventaboletos.service.SistemaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import java.util.Calendar;
import java.util.List;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Button;
import org.zkoss.zul.Textbox;

/**
 *
 * @author rodrigo
 */
@Controller("editarMenuController")
@Scope("prototype")
public class EditarMenuController extends MyGenericForwardComposer {

    @Autowired
    private FuncionSistemaService funcionSistemaService;
    @Autowired
    private SistemaService sistemaService;
    private List<Sistema> lsSistema;
    private FuncionSistema funcionSistema;
    private MyListbox menuList;
    private Textbox txtNombFuncion;
    private Button btnApagar;
    private static Logger log = Logger.getLogger(EditarMenuController.class);

    public FuncionSistema getFuncionSistema() {
        return funcionSistema;
    }

    public void setFuncionSistema(FuncionSistema funcionSistema) {
        this.funcionSistema = funcionSistema;
    }

    public List<Sistema> getLsSistema() {
        return lsSistema;
    }

    public void setLsSistema(List<Sistema> lsSistema) {
        this.lsSistema = lsSistema;
    }

    public Textbox getTxtNombFuncion() {
        return txtNombFuncion;
    }

    public void setTxtNombFuncion(Textbox txtNombFuncion) {
        this.txtNombFuncion = txtNombFuncion;
    }

    public Button getBtnApagar() {
        return btnApagar;
    }

    public void setBtnApagar(Button btnApagar) {
        this.btnApagar = btnApagar;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        lsSistema = sistemaService.obtenerTodos();

        funcionSistema = (FuncionSistema) Executions.getCurrent().getArg().get("menu");
        menuList = (MyListbox) Executions.getCurrent().getArg().get("menuList");

        if (funcionSistema.getFuncionsistemaId() == null) {
            btnApagar.setVisible(Boolean.FALSE);
        }

        txtNombFuncion.focus();
    }

    public void onClick$btnSalvar(Event ev) {
        txtNombFuncion.getText();

        try {
            funcionSistema.setActivo(Boolean.TRUE);
            funcionSistema.setFecmodif(Calendar.getInstance().getTime());
            funcionSistema.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());

            if (funcionSistema.getFuncionsistemaId() == null) {
                funcionSistemaService.suscribir(funcionSistema);
                menuList.addItem(funcionSistema);
            } else {
                funcionSistemaService.actualizacion(funcionSistema);
                menuList.updateItem(funcionSistema);
            }

            Messagebox.show(
                    Labels.getLabel("editarMenuController.MSG.suscribirOK"),
                    Labels.getLabel("editarMenuController.window.title"),
                    Messagebox.OK, Messagebox.INFORMATION);

            closeWindow();
        } catch (Exception ex) {
            log.error(ex);
        }
    }

    public void onClick$btnApagar(Event ev) {
        try {
            int resp = Messagebox.show(
                    Labels.getLabel("editarMenuController.MSG.borrarPergunta"),
                    Labels.getLabel("editarMenuController.window.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

            if (resp == Messagebox.YES) {
                funcionSistemaService.borrar(funcionSistema);

                Messagebox.show(
                        Labels.getLabel("editarMenuController.MSG.borrarOK"),
                        Labels.getLabel("editarMenuController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                menuList.removeItem(funcionSistema);

                closeWindow();
            }
        } catch (Exception ex) {
            log.error(ex);
        }
    }
}
